# Turn logs into stripped logs when a tree is struck by lightning, similar to how lightning can blow the bark off of tree trunks in real life
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:oak_leaves run fill ~2 ~ ~2 ~-2 ~-14 ~-2 minecraft:stripped_oak_log replace minecraft:oak_log
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:spruce_leaves run fill ~3 ~ ~3 ~-3 ~-24 ~-3 minecraft:stripped_spruce_log replace minecraft:spruce_log
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:birch_leaves run fill ~2 ~ ~2 ~-2 ~-12 ~-2 minecraft:stripped_birch_log replace minecraft:birch_log
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:jungle_leaves run fill ~4 ~ ~4 ~-4 ~-28 ~-4 minecraft:stripped_jungle_log replace minecraft:jungle_log
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:acacia_leaves run fill ~3 ~ ~3 ~-3 ~-12 ~-3 minecraft:stripped_acacia_log replace minecraft:acacia_log
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:dark_oak_leaves run fill ~3 ~ ~3 ~-3 ~-14 ~-3 minecraft:stripped_dark_oak_log replace minecraft:dark_oak_log
##################################################################################################


# Turns sand and red sand into clear glass when struck
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ #minecraft:sand run setblock ~ ~-1 ~ minecraft:glass
##################################################################################################


# If soul sand is struck, it turns into black stained glass and 3 vexes spawn (to represent the supposed souls that were trapped inside the sand)
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~ ~ minecraft:soul_sand run summon minecraft:armor_stand ~ ~ ~ {NoGravity: 1b, Invulnerable: 1b, Marker: 1b, Invisible: 1b, PersistenceRequired: 1b, Tags:["soul_sand_struck"]}
##################################################################################################


# If a slime block is struck, it comes back to life as a medium slime
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~-1 ~ minecraft:slime_block run summon minecraft:armor_stand ~ ~ ~ {NoGravity: 1b, Invulnerable: 1b, Marker: 1b, Invisible: 1b, PersistenceRequired: 1b, Tags:["slime_block_struck"]}
##################################################################################################


# If a flower is struck, it turns into a wither rose
execute as @e[type=minecraft:lightning_bolt] at @s if block ~ ~ ~ #minecraft:small_flowers run setblock ~ ~ ~ minecraft:wither_rose
##################################################################################################


# Charged creepers receive practically indefinite fire resistance
execute as @e[type=minecraft:creeper, nbt={powered:1b}] at @s run effect give @s minecraft:fire_resistance 1 0 true
##################################################################################################


# Entities struck by lightning receive blindness for a few seconds and weakness for 2 minutes (except for ones already affected by lightning)
execute as @e[type=minecraft:lightning_bolt] at @s run tag @e[type=!minecraft:iron_golem, type=!minecraft:vex, type=!#minecraft:skeletons, type=!minecraft:slime, type=!minecraft:creeper, type=!minecraft:witch, type=!minecraft:mooshroom, type=!minecraft:zombie_horse, type=!minecraft:skeleton_horse, type=!minecraft:zoglin, distance=..3] add struck_by_lightning
##################################################################################################


# If a pig is struck it turns into a zoglin instead of a zombie piglin
execute as @e[type=minecraft:lightning_bolt] at @s run tag @e[type=minecraft:pig, distance=..4] add pig_struck
##################################################################################################


# If a horse gets struck, there's a 50/50 chance of it turning into a skeleton horse or a zombie horse
execute as @e[type=minecraft:lightning_bolt] at @s run tag @e[type=minecraft:horse, distance=..3] add horse_struck
##################################################################################################


# If a zombie gets struck it turns into an unarmed skeleton
execute as @e[type=minecraft:lightning_bolt] at @s run tag @e[type=minecraft:zombie, distance=..3] add zombie_struck
##################################################################################################


# If a skeleton or a stray gets struck WHILE UNDER THE WITHER EFFECT, it turns into a wither skeleton armed with a bow
execute as @e[type=minecraft:lightning_bolt] at @s run tag @e[type=#minecraft:skeletons, nbt={ActiveEffects:[{Id:20b}]}, distance=..3] add skeleton_struck
##################################################################################################


# If an iron golem gets struck it becomes charged, gaining speed, strength, and fire resistance for 30 seconds
execute as @e[type=minecraft:lightning_bolt] at @s run tag @e[type=minecraft:iron_golem, distance=..3] add golem_struck
##################################################################################################
